<div
  class="flex-fixed-size buttons-area"
  [attr.data-test-element-id]="'button-area'"
>
  <div class="full-width">
    <div class="header-toolbar-grid full-width">
      <div class="execution-step-info flex full-width" style="overflow: hidden">
        @if (step.extended) {
          <i
            [attr.data-test-element-id]="'collapse-step'"
            class="m-r-20 arrow-button"
            nz-icon
            nzType="caret-down"
            nzTheme="outline"
            (click)="toggleStep()"
          ></i>
        } @else {
          <i
            [attr.data-test-element-id]="'extend-step'"
            class="m-r-20"
            nz-icon
            nzType="caret-right"
            nzTheme="outline"
            (click)="toggleStep()"
          ></i>
        }

        <div
          class="step-execution-status flex m-r-15"
          [style.background-color]="
            getExecutionStatusColor(step.executionStatus)
          "
          [style.border-color]="getExecutionStatusColor(step.executionStatus)"
        >
          <span
            class="step-execution-status-text m-l-6 m-r-6"
            [style.color]="getStepStatusTextColor()"
            >{{ getStepStatusI18nKey() | translate }}</span
          >
        </div>
        @if (step.lastExecutedOn) {
          <label
            nz-tooltip
            [sqtmCoreLabelTooltip]="
              getLastExecution(step.lastExecutedOn, step.lastExecutedBy)
            "
            class="text-ellipsis"
          >
            {{
              getLastExecution(step.lastExecutedOn, step.lastExecutedBy)
            }}</label
          >
        }
        @if (step.comment) {
          <span class="info-icon m-l-15">
            <i
              nz-icon
              nzType="sqtm-core-campaign:comments"
              nzTheme="outline"
            ></i>
          </span>
        }
        @if (attachmentCount > 0) {
          <div class="info-icon counter-icon-container m-l-10">
            <i
              nz-icon
              nzType="sqtm-core-generic:attachments"
              nzTheme="outline"
            ></i>
            <div class="flex">
              <span class="counter">{{ attachmentCount }}</span>
            </div>
          </div>
        }
        @if (issuesNb > 0) {
          <div class="info-icon counter-icon-container m-l-10">
            <i nz-icon nzType="sqtm-core-generic:issues" nzTheme="outline"></i>
            <div class="flex">
              <span class="counter">{{ issuesNb }}</span>
            </div>
          </div>
        }
      </div>
      <div class="action-buttons flex full-width">
        @if (canEditExecution && execution.executionMode === 'MANUAL') {
          <button
            class="status-button"
            nz-button
            nz-tooltip="{{
              executionStatus.SUCCESS.i18nKey | translate | capitalize
            }}"
            [nzTooltipPlacement]="'bottom'"
            [nzSize]="'small'"
            [attr.data-test-execution-status]="executionStatus.SUCCESS.id"
            [style.background-color]="
              getExecutionStatusColor(executionStatus.SUCCESS.id)
            "
            [style.border-color]="
              getExecutionStatusColor(executionStatus.SUCCESS.id)
            "
            (click)="changeExecutionStepStatus(executionStatus.SUCCESS.id)"
          >
            <span class="m-l-4"></span>
          </button>
        }
        @if (canEditExecution && execution.executionMode === 'MANUAL') {
          <button
            class="status-button"
            nz-button
            nz-tooltip="{{
              executionStatus.FAILURE.i18nKey | translate | capitalize
            }}"
            [nzTooltipPlacement]="'bottom'"
            [nzSize]="'small'"
            [attr.data-test-execution-status]="executionStatus.FAILURE.id"
            [style.background-color]="
              getExecutionStatusColor(executionStatus.FAILURE.id)
            "
            [style.border-color]="
              getExecutionStatusColor(executionStatus.FAILURE.id)
            "
            (click)="changeExecutionStepStatus(executionStatus.FAILURE.id)"
          >
            <span class="m-l-4"></span>
          </button>
        }
        @if (canEditExecution && execution.executionMode === 'MANUAL') {
          <button
            class="status-button"
            nz-button
            nz-tooltip="{{
              executionStatus.BLOCKED.i18nKey | translate | capitalize
            }}"
            [nzTooltipPlacement]="'bottom'"
            [nzSize]="'small'"
            [attr.data-test-execution-status]="executionStatus.BLOCKED.id"
            [style.background-color]="
              getExecutionStatusColor(executionStatus.BLOCKED.id)
            "
            [style.border-color]="
              getExecutionStatusColor(executionStatus.BLOCKED.id)
            "
            (click)="changeExecutionStepStatus(executionStatus.BLOCKED.id)"
          >
            <span class="m-l-4"></span>
          </button>
        }

        @if (canEditExecution && execution.executionMode === 'MANUAL') {
          <i
            [attr.data-test-toolbar-button-id]="'optional-status-button'"
            class="m-r-5 tree-icon-size current-workspace-button"
            nz-icon
            nzType="sqtm-core-generic:more"
            nzTheme="outline"
            nz-dropdown
            [nzDropdownMenu]="optionalStatusMenu"
          ></i>
        }

        <nz-dropdown-menu #optionalStatusMenu="nzDropdownMenu">
          <ul [attr.data-test-menu-id]="'optional-status-menu'" nz-menu>
            @if (isVisible(executionStatus.UNTESTABLE.id)) {
              <li
                nz-menu-item
                [attr.data-test-menu-item-id]="executionStatus.UNTESTABLE.id"
                (click)="
                  changeExecutionStepStatus(executionStatus.UNTESTABLE.id)
                "
              >
                <div class="flex-row">
                  <div
                    class="optional-status"
                    [style.background-color]="
                      getExecutionStatusColor(executionStatus.UNTESTABLE.id)
                    "
                    [style.border-color]="
                      getExecutionStatusColor(executionStatus.UNTESTABLE.id)
                    "
                  ></div>
                  {{
                    executionStatus.UNTESTABLE.i18nKey | translate | capitalize
                  }}
                </div>
              </li>
            }
            @if (isVisible(executionStatus.SETTLED.id)) {
              <li
                nz-menu-item
                [attr.data-test-menu-item-id]="executionStatus.SETTLED.id"
                (click)="changeExecutionStepStatus(executionStatus.SETTLED.id)"
              >
                <div class="flex-row">
                  <div
                    class="optional-status"
                    [style.background-color]="
                      getExecutionStatusColor(executionStatus.SETTLED.id)
                    "
                    [style.border-color]="
                      getExecutionStatusColor(executionStatus.SETTLED.id)
                    "
                  ></div>
                  {{ executionStatus.SETTLED.i18nKey | translate | capitalize }}
                </div>
              </li>
            }
            <li
              nz-menu-item
              [attr.data-test-menu-item-id]="executionStatus.READY.id"
              (click)="changeExecutionStepStatus(executionStatus.READY.id)"
            >
              <div class="flex-row">
                <div
                  class="optional-status"
                  [style.background-color]="
                    getExecutionStatusColor(executionStatus.READY.id)
                  "
                  [style.border-color]="
                    getExecutionStatusColor(executionStatus.READY.id)
                  "
                ></div>
                {{ executionStatus.READY.i18nKey | translate | capitalize }}
              </div>
            </li>
          </ul>
        </nz-dropdown-menu>

        @if (isActionMenuVisible) {
          <i
            [attr.data-test-toolbar-button-id]="'step-action-button'"
            [nzDropdownMenu]="menu"
            class="m-r-5 tree-icon-size current-workspace-button"
            nz-dropdown
            nz-icon
            nzTheme="outline"
            nzType="sqtm-core-generic:plus"
          >
          </i>
        }

        <nz-dropdown-menu #menu="nzDropdownMenu">
          <ul [attr.data-test-menu-id]="'step-action-menu'" nz-menu>
            @if (canAddComment) {
              <li
                (click)="addComment()"
                [attr.data-test-menu-item-id]="'add-comment'"
                nz-menu-item
              >
                {{
                  'sqtm-core.campaign-workspace.execution-page.comment.add-comment.label'
                    | translate
                }}
              </li>
            }
            @if (canAddAttachment) {
              <li
                class="no-padding"
                nz-menu-item
                [attr.data-test-menu-item-id]="'add-attachments'"
              >
                <sqtm-core-attachment-file-selector
                  class="item-style"
                  (uploadFilesEvent)="addAttachmentToStep($event)"
                >
                  {{
                    'sqtm-core.entity.attachment.add-attachment.label'
                      | translate
                  }}
                </sqtm-core-attachment-file-selector>
              </li>
            }
            @if (canAddIssue) {
              <li
                (click)="addIssue(false)"
                [attr.data-test-menu-item-id]="'add-issue'"
                nz-menu-item
              >
                {{
                  'sqtm-core.campaign-workspace.execution-page.issue.add-issue'
                    | translate
                }}
              </li>
            }
            @if (canAddIssue) {
              <li
                (click)="addIssue(true)"
                [attr.data-test-menu-item-id]="'link-existing-issue'"
                nz-menu-item
              >
                {{
                  'sqtm-core.campaign-workspace.dialog.title.attach-issue'
                    | translate
                }}
              </li>
            }
          </ul>
        </nz-dropdown-menu>
      </div>
    </div>
  </div>
</div>
